Package com.io7m.smfj.processing.api

## Interface SMFAttributeArrayIntegerUnsigned3Type

- All Superinterfaces:
    `SMFAttributeArrayType`
  All Known Implementing Classes:
    `SMFAttributeArrayIntegerUnsigned3`

      @Immutable
      public interface SMFAttributeArrayIntegerUnsigned3Type
      extends SMFAttributeArrayType

  The type of 3-element unsigned integer arrays.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default <A,​B,​E extends java.lang.Exception> B` | `matchArray​(A context, SMFPartialBiFunctionType<A,​SMFAttributeArrayFloating4Type,​B,​E> on_f4, SMFPartialBiFunctionType<A,​SMFAttributeArrayFloating3Type,​B,​E> on_f3, SMFPartialBiFunctionType<A,​SMFAttributeArrayFloating2Type,​B,​E> on_f2, SMFPartialBiFunctionType<A,​SMFAttributeArrayFloating1Type,​B,​E> on_f1, SMFPartialBiFunctionType<A,​SMFAttributeArrayIntegerUnsigned4Type,​B,​E> on_u4, SMFPartialBiFunctionType<A,​SMFAttributeArrayIntegerUnsigned3Type,​B,​E> on_u3, SMFPartialBiFunctionType<A,​SMFAttributeArrayIntegerUnsigned2Type,​B,​E> on_u2, SMFPartialBiFunctionType<A,​SMFAttributeArrayIntegerUnsigned1Type,​B,​E> on_u1, SMFPartialBiFunctionType<A,​SMFAttributeArrayIntegerSigned4Type,​B,​E> on_i4, SMFPartialBiFunctionType<A,​SMFAttributeArrayIntegerSigned3Type,​B,​E> on_i3, SMFPartialBiFunctionType<A,​SMFAttributeArrayIntegerSigned2Type,​B,​E> on_i2, SMFPartialBiFunctionType<A,​SMFAttributeArrayIntegerSigned1Type,​B,​E> on_i1)` | Match on the type of array.
    `default int` | `size()` |
    `java.util.List<com.io7m.jtensors.core.unparameterized.vectors.Vector3L>` | `values()` |

- - ### Method Detail

    - #### matchArray

          default <A,​B,​E extends java.lang.Exception> B matchArray​(A context,
                                                                               SMFPartialBiFunctionType<A,​SMFAttributeArrayFloating4Type,​B,​E> on_f4,
                                                                               SMFPartialBiFunctionType<A,​SMFAttributeArrayFloating3Type,​B,​E> on_f3,
                                                                               SMFPartialBiFunctionType<A,​SMFAttributeArrayFloating2Type,​B,​E> on_f2,
                                                                               SMFPartialBiFunctionType<A,​SMFAttributeArrayFloating1Type,​B,​E> on_f1,
                                                                               SMFPartialBiFunctionType<A,​SMFAttributeArrayIntegerUnsigned4Type,​B,​E> on_u4,
                                                                               SMFPartialBiFunctionType<A,​SMFAttributeArrayIntegerUnsigned3Type,​B,​E> on_u3,
                                                                               SMFPartialBiFunctionType<A,​SMFAttributeArrayIntegerUnsigned2Type,​B,​E> on_u2,
                                                                               SMFPartialBiFunctionType<A,​SMFAttributeArrayIntegerUnsigned1Type,​B,​E> on_u1,
                                                                               SMFPartialBiFunctionType<A,​SMFAttributeArrayIntegerSigned4Type,​B,​E> on_i4,
                                                                               SMFPartialBiFunctionType<A,​SMFAttributeArrayIntegerSigned3Type,​B,​E> on_i3,
                                                                               SMFPartialBiFunctionType<A,​SMFAttributeArrayIntegerSigned2Type,​B,​E> on_i2,
                                                                               SMFPartialBiFunctionType<A,​SMFAttributeArrayIntegerSigned1Type,​B,​E> on_i1)
                                                                        throws E extends java.lang.Exception

      Description copied from interface: `SMFAttributeArrayType`
      Match on the type of array.
      Specified by:
        `matchArray` in interface `SMFAttributeArrayType`
      Type Parameters:
        `A` - The type of contextual values
        `B` - The type of returned values
        `E` - The type of raised exceptions
      Parameters:
        `context` - A contextual value
        `on_f4` - A receiver function
        `on_f3` - A receiver function
        `on_f2` - A receiver function
        `on_f1` - A receiver function
        `on_u4` - A receiver function
        `on_u3` - A receiver function
        `on_u2` - A receiver function
        `on_u1` - A receiver function
        `on_i4` - A receiver function
        `on_i3` - A receiver function
        `on_i2` - A receiver function
        `on_i1` - A receiver function
      Returns:
        A value of `A`
      Throws:
        `E` - If any of the functions raise `E`
        `E extends java.lang.Exception`

    - #### size

          default int size()

      Specified by:
        `size` in interface `SMFAttributeArrayType`
      Returns:
        The size of the array

    - #### values

          @Parameter
          java.util.List<com.io7m.jtensors.core.unparameterized.vectors.Vector3L> values()

      Returns:
        The array values